package com.sun.java.util.jar.pack;

import java.util.SortedMap;
import java.util.ListIterator;
import java.util.TreeMap;
import java.util.List;
import java.nio.file.Files;
import java.nio.file.attribute.FileAttribute;
import java.io.IOException;
import java.io.InputStream;
import java.util.Iterator;
import java.util.jar.JarOutputStream;
import java.util.zip.GZIPInputStream;
import java.io.BufferedInputStream;
import java.util.zip.GZIPOutputStream;
import java.io.BufferedOutputStream;
import java.util.jar.JarFile;
import java.io.File;
import java.util.jar.Pack200;
import java.io.PrintStream;
import java.io.FileOutputStream;
import java.text.MessageFormat;
import java.util.Map;
import java.io.FileInputStream;
import java.util.Properties;
import java.util.HashMap;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.ResourceBundle;

class Driver
{
    private static final ResourceBundle RESOURCE;
    private static final String PACK200_OPTION_MAP = "--repack                 $ \n  -r +>- @--repack              $ \n--no-gzip                $ \n  -g +>- @--no-gzip             $ \n--strip-debug            $ \n  -G +>- @--strip-debug         $ \n--no-keep-file-order     $ \n  -O +>- @--no-keep-file-order  $ \n--segment-limit=      *> = \n  -S +>  @--segment-limit=      = \n--effort=             *> = \n  -E +>  @--effort=             = \n--deflate-hint=       *> = \n  -H +>  @--deflate-hint=       = \n--modification-time=  *> = \n  -m +>  @--modification-time=  = \n--pass-file=        *> &\u0000 \n  -P +>  @--pass-file=        &\u0000 \n--unknown-attribute=  *> = \n  -U +>  @--unknown-attribute=  = \n--class-attribute=  *> &\u0000 \n  -C +>  @--class-attribute=  &\u0000 \n--field-attribute=  *> &\u0000 \n  -F +>  @--field-attribute=  &\u0000 \n--method-attribute= *> &\u0000 \n  -M +>  @--method-attribute= &\u0000 \n--code-attribute=   *> &\u0000 \n  -D +>  @--code-attribute=   &\u0000 \n--config-file=      *>   . \n  -f +>  @--config-file=        . \n--no-strip-debug  !--strip-debug         \n--gzip            !--no-gzip             \n--keep-file-order !--no-keep-file-order  \n--verbose                $ \n  -v +>- @--verbose             $ \n--quiet        !--verbose  \n  -q +>- !--verbose               \n--log-file=           *> = \n  -l +>  @--log-file=           = \n--version                . \n  -V +>  @--version             . \n--help               . \n  -? +> @--help . \n  -h +> @--help . \n--           . \n-   +?    >- . \n";
    private static final String UNPACK200_OPTION_MAP = "--deflate-hint=       *> = \n  -H +>  @--deflate-hint=       = \n--verbose                $ \n  -v +>- @--verbose             $ \n--quiet        !--verbose  \n  -q +>- !--verbose               \n--remove-pack-file       $ \n  -r +>- @--remove-pack-file    $ \n--log-file=           *> = \n  -l +>  @--log-file=           = \n--config-file=        *> . \n  -f +>  @--config-file=        . \n--           . \n-   +?    >- . \n--version                . \n  -V +>  @--version             . \n--help               . \n  -? +> @--help . \n  -h +> @--help . \n";
    private static final String[] PACK200_PROPERTY_TO_OPTION;
    private static final String[] UNPACK200_PROPERTY_TO_OPTION;
    
    Driver() {
    }
    
    public static void main(String[] a) throws IOException {
        ArrayList list = new ArrayList(Arrays.asList(a));
        boolean n = true;
        boolean n2 = false;
        int n3 = 0;
        int n4 = 1;
        String name = null;
        String key = "com.sun.java.util.jar.pack.verbose";
        String s = (list.isEmpty() ? "" : ((String)list.get(0)));
        int n5 = -1;
        switch (s.hashCode()) {
            case 1333303225: {
                if (s.equals("--pack")) {
                    n5 = 0;
                    break;
                }
                break;
            }
            case 1559677394: {
                if (s.equals("--unpack")) {
                    n5 = 1;
                    break;
                }
                break;
            }
        }
        switch (n5) {
            case 0: {
                list.remove(0);
                break;
            }
            case 1: {
                list.remove(0);
                n = false;
                n2 = true;
                break;
            }
        }
        HashMap o = new HashMap();
        o.put(key, System.getProperty(key));
        String s2;
        String[] array;
        if (n != 0) {
            s2 = "--repack                 $ \n  -r +>- @--repack              $ \n--no-gzip                $ \n  -g +>- @--no-gzip             $ \n--strip-debug            $ \n  -G +>- @--strip-debug         $ \n--no-keep-file-order     $ \n  -O +>- @--no-keep-file-order  $ \n--segment-limit=      *> = \n  -S +>  @--segment-limit=      = \n--effort=             *> = \n  -E +>  @--effort=             = \n--deflate-hint=       *> = \n  -H +>  @--deflate-hint=       = \n--modification-time=  *> = \n  -m +>  @--modification-time=  = \n--pass-file=        *> &\u0000 \n  -P +>  @--pass-file=        &\u0000 \n--unknown-attribute=  *> = \n  -U +>  @--unknown-attribute=  = \n--class-attribute=  *> &\u0000 \n  -C +>  @--class-attribute=  &\u0000 \n--field-attribute=  *> &\u0000 \n  -F +>  @--field-attribute=  &\u0000 \n--method-attribute= *> &\u0000 \n  -M +>  @--method-attribute= &\u0000 \n--code-attribute=   *> &\u0000 \n  -D +>  @--code-attribute=   &\u0000 \n--config-file=      *>   . \n  -f +>  @--config-file=        . \n--no-strip-debug  !--strip-debug         \n--gzip            !--no-gzip             \n--keep-file-order !--no-keep-file-order  \n--verbose                $ \n  -v +>- @--verbose             $ \n--quiet        !--verbose  \n  -q +>- !--verbose               \n--log-file=           *> = \n  -l +>  @--log-file=           = \n--version                . \n  -V +>  @--version             . \n--help               . \n  -? +> @--help . \n  -h +> @--help . \n--           . \n-   +?    >- . \n";
            array = Driver.PACK200_PROPERTY_TO_OPTION;
        }
        else {
            s2 = "--deflate-hint=       *> = \n  -H +>  @--deflate-hint=       = \n--verbose                $ \n  -v +>- @--verbose             $ \n--quiet        !--verbose  \n  -q +>- !--verbose               \n--remove-pack-file       $ \n  -r +>- @--remove-pack-file    $ \n--log-file=           *> = \n  -l +>  @--log-file=           = \n--config-file=        *> . \n  -f +>  @--config-file=        . \n--           . \n-   +?    >- . \n--version                . \n  -V +>  @--version             . \n--help               . \n  -? +> @--help . \n  -h +> @--help . \n";
            array = Driver.UNPACK200_PROPERTY_TO_OPTION;
        }
        HashMap o2 = new HashMap();
        while (true) {
            try {
                String commandOptions = parseCommandOptions(list, s2, o2);
                Iterator<Object> iterator = o2.keySet().iterator();
                while (iterator.hasNext()) {
                    String s3 = (String)iterator.next();
                    String s4 = null;
                    int i = 0;
                    while (i < array.length) {
                        if (s3.equals(array[1 + i])) {
                            s4 = array[0 + i];
                            break;
                        }
                        i += 2;
                    }
                    if (s4 != null) {
                        String s5 = (String)o2.get(s3);
                        iterator.remove();
                        if (!s4.endsWith(".")) {
                            if (!s3.equals("--verbose") && !s3.endsWith("=")) {
                                int n7 = s5 != null;
                                if (s3.startsWith("--no-")) {
                                    n7 = (n7 == 0);
                                }
                                s5 = (n7 ? "true" : "false");
                            }
                            o.put(s4, s5);
                        }
                        else if (s4.contains(".attribute.")) {
                            String[] split2 = s5.split("\u0000");
                            for (int length2 = split2.length, k = 0; k < length2; ++k) {
                                String[] split3 = split2[k].split("=", 2);
                                o.put(s4 + split3[0], split3[1]);
                            }
                        }
                        else {
                            int n6 = 1;
                            for (String s6 : s5.split("\u0000")) {
                                String string;
                                do {
                                    string = s4 + "cli." + n6++;
                                } while (o.containsKey(string));
                                o.put(string, s6);
                            }
                        }
                    }
                    else {
                        continue;
                    }
                }
                if ("--config-file=".equals(commandOptions)) {
                    String name2 = (String)list.remove(0);
                    Properties o3 = new Properties();
                    try (final Object inStream = new FileInputStream(name2)) {
                        o3.load(inStream);
                    }
                    if (o.get(key) != null) {
                        o3.list(System.out);
                    }
                    for (Map.Entry entry : o3.entrySet()) {
                        o.put((Object)entry.getKey(), (Object)entry.getValue());
                    }
                    continue;
                }
                if ("--version".equals(commandOptions)) {
                    System.out.println(MessageFormat.format(Driver.RESOURCE.getString("VERSION"), new Object[] { Driver.class.getName(), "1.31, 07/05/05" }));
                    return;
                }
                if ("--help".equals(commandOptions)) {
                    printUsage((boolean)n, true, System.out);
                    System.exit(1);
                    return;
                }
                break;
            }
            catch (IllegalArgumentException ex) {
                System.err.println(MessageFormat.format(Driver.RESOURCE.getString("BAD_ARGUMENT"), new Object[] { ex }));
                printUsage((boolean)n, false, System.err);
                System.exit(2);
                return;
            }
        }
        for (String s7 : o2.keySet()) {
            String s8 = (String)o2.get(s7);
            int n8 = -1;
            switch (s7.hashCode()) {
                case 1465478252: {
                    if (s7.equals("--repack")) {
                        n8 = 0;
                        break;
                    }
                    break;
                }
                case -845245370: {
                    if (s7.equals("--no-gzip")) {
                        n8 = 1;
                        break;
                    }
                    break;
                }
                case 1339571416: {
                    if (s7.equals("--log-file=")) {
                        n8 = 2;
                        break;
                    }
                    break;
                }
            }
            switch (n8) {
                case 0: {
                    n3 = 1;
                    continue;
                }
                case 1: {
                    n4 = (s8 == null);
                    continue;
                }
                case 2: {
                    name = s8;
                    continue;
                }
                default: {
                    throw new InternalError(MessageFormat.format(Driver.RESOURCE.getString("BAD_OPTION"), new Object[] { s7, o2.get(s7) }));
                }
            }
        }
        if (name != null && !name.equals("")) {
            if (name.equals("-")) {
                System.setErr(System.out);
            }
            else {
                System.setErr(new PrintStream(new FileOutputStream(name)));
            }
        }
        int n9 = o.get(key) != null;
        String path = "";
        if (!list.isEmpty()) {
            path = (String)list.remove(0);
        }
        String s9 = "";
        if (!list.isEmpty()) {
            s9 = (String)list.remove(0);
        }
        String name3 = "";
        String path2 = "";
        String s10 = "";
        if (n3 != 0) {
            if (path.toLowerCase().endsWith(".pack") || path.toLowerCase().endsWith(".pac") || path.toLowerCase().endsWith(".gz")) {
                System.err.println(MessageFormat.format(Driver.RESOURCE.getString("BAD_REPACK_OUTPUT"), new Object[] { path }));
                printUsage((boolean)n, false, System.err);
                System.exit(2);
            }
            name3 = path;
            if (s9.equals("")) {
                s9 = name3;
            }
            s10 = (path = createTempFile(name3, ".pack").getPath());
            n4 = 0;
        }
        if (!list.isEmpty() || (!s9.toLowerCase().endsWith(".jar") && !s9.toLowerCase().endsWith(".zip") && (!s9.equals("-") || n))) {
            printUsage((boolean)n, false, System.err);
            System.exit(2);
            return;
        }
        if (n3 != 0) {
            n2 = (n = true);
        }
        else if (n != 0) {
            n2 = false;
        }
        Pack200.Packer packer = Pack200.newPacker();
        Pack200.Unpacker unpacker = Pack200.newUnpacker();
        packer.properties().putAll(o);
        unpacker.properties().putAll(o);
        if (n3 != 0 && name3.equals(s9)) {
            String zipComment = getZipComment(s9);
            if (n9 && zipComment.length() > 0) {
                System.out.println(MessageFormat.format(Driver.RESOURCE.getString("DETECTED_ZIP_COMMENT"), new Object[] { zipComment }));
            }
            if (zipComment.indexOf("PACK200") >= 0) {
                System.out.println(MessageFormat.format(Driver.RESOURCE.getString("SKIP_FOR_REPACKED"), new Object[] { s9 }));
                n = false;
                n2 = false;
                n3 = 0;
            }
        }
        try {
            if (n != 0) {
                JarFile o4 = new JarFile(new File(s9));
                PrintStream out;
                if (path.equals("-")) {
                    out = System.out;
                    System.setOut(System.err);
                }
                else if (n4 != 0) {
                    if (!path.endsWith(".gz")) {
                        System.err.println(MessageFormat.format(Driver.RESOURCE.getString("WRITE_PACK_FILE"), new Object[] { path }));
                        printUsage((boolean)n, false, System.err);
                        System.exit(2);
                    }
                    out = new GZIPOutputStream(new BufferedOutputStream(new FileOutputStream(path)));
                }
                else {
                    if (!path.toLowerCase().endsWith(".pack") && !path.toLowerCase().endsWith(".pac")) {
                        System.err.println(MessageFormat.format(Driver.RESOURCE.getString("WRITE_PACKGZ_FILE"), new Object[] { path }));
                        printUsage((boolean)n, false, System.err);
                        System.exit(2);
                    }
                    out = new BufferedOutputStream(new FileOutputStream(path));
                }
                packer.pack(o4, out);
                out.close();
            }
            if (n3 != 0 && name3.equals(s9)) {
                File tempFile = createTempFile(s9, ".bak");
                tempFile.delete();
                if (!new File(s9).renameTo(tempFile)) {
                    throw new Error(MessageFormat.format(Driver.RESOURCE.getString("SKIP_FOR_MOVE_FAILED"), new Object[] { path2 }));
                }
                path2 = tempFile.getPath();
            }
            if (!(n2 == 0)) {
                InputStream in;
                if (path.equals("-")) {
                    in = System.in;
                }
                else {
                    in = new FileInputStream(new File(path));
                }
                Object in2;
                if (Utils.isGZIPMagic(Utils.readMagic(in2 = new BufferedInputStream(in)))) {
                    in2 = new GZIPInputStream(in2);
                }
                name3 = (name3.equals("") ? s9 : name3);
                PrintStream out2;
                if (name3.equals("-")) {
                    out2 = System.out;
                }
                else {
                    out2 = new FileOutputStream(name3);
                }
                try (final Object o5 = new JarOutputStream(new BufferedOutputStream(out2))) {
                    unpacker.unpack(in2, o5);
                }
            }
            if (!path2.equals("")) {
                new File(path2).delete();
                path2 = "";
            }
            if (!path2.equals("")) {
                File dest = new File(s9);
                dest.delete();
                new File(path2).renameTo(dest);
            }
            if (!s10.equals("")) {
                new File(s10).delete();
            }
        }
        finally {
            if (!path2.equals("")) {
                File dest2 = new File(s9);
                dest2.delete();
                new File(path2).renameTo(dest2);
            }
            if (!s10.equals("")) {
                new File(s10).delete();
            }
        }
        return;
    }
    
    private static File createTempFile(String pathname, String s) throws IOException {
        File file = new File(pathname);
        String prefix = file.getName();
        if (prefix.length() < 3) {
            prefix += "tmp";
        }
        File file2 = (file.getParentFile() == null && s.equals(".bak")) ? new File(".").getAbsoluteFile() : file.getParentFile();
        return ((file2 == null) ? Files.createTempFile(prefix, s, new FileAttribute[0]) : Files.createTempFile(file2.toPath(), prefix, s, new FileAttribute[0])).toFile();
    }
    
    private static void printUsage(boolean b, boolean b2, PrintStream printStream) {
        String s = b ? "pack200" : "unpack200";
        String[] array = (String[])(String[])Driver.RESOURCE.getObject("PACK_HELP");
        String[] array2 = (String[])(String[])Driver.RESOURCE.getObject("UNPACK_HELP");
        array2 = (b ? array : array2);
        int i = 0;
        while (i < array2.length) {
            printStream.println(array2[i]);
            if (!b2) {
                printStream.println(MessageFormat.format(Driver.RESOURCE.getString("MORE_INFO"), new Object[] { s }));
                break;
            }
            ++i;
        }
    }
    
    private static String getZipComment(String s) throws IOException {
        byte[] array = new byte[1000];
        long length = new File(s).length();
        if (length <= 0L) {
            return "";
        }
        long max = Math.max(0L, length - (long)array.length);
        try (final FileInputStream fileInputStream = new FileInputStream(new File(s))) {
            fileInputStream.skip(max);
            fileInputStream.read(array);
            int i = array.length - 4;
            while (i >= 0) {
                if (array[i + 0] == 80 && array[i + 1] == 75 && array[i + 2] == 5 && array[i + 3] == 6) {
                    i += 22;
                    if (i < array.length) {
                        return new String(array, i, array.length - i, "UTF8");
                    }
                    else {
                        return "";
                    }
                }
                else {
                    --i;
                }
            }
            return "";
        }
    }
    
    private static String parseCommandOptions(List<String> list, String s, Map<String, String> map) {
        String string = null;
        TreeMap<String, String> treeMap = new TreeMap();
        for (String s2 : s.split("\n")) {
            String[] split2 = s2.split("\\p{Space}+");
            if (split2.length != 0) {
                String key = split2[0];
                split2[0] = "";
                if (key.length() == 0 && split2.length >= 1) {
                    key = split2[1];
                    split2[1] = "";
                }
                if (key.length() != 0 && (String[])treeMap.put(key, split2) != null) {
                    throw new RuntimeException(MessageFormat.format(Driver.RESOURCE.getString("DUPLICATE_OPTION"), new Object[] { s2.trim() }));
                }
            }
        }
        ListIterator<Object> listIterator = list.listIterator();
        ListIterator<String> listIterator2 = new ArrayList().listIterator();
    Label_1211:
        while (true) {
            String str;
            if (listIterator2.hasPrevious()) {
                str = (String)listIterator2.previous();
                listIterator2.remove();
            }
            else if (listIterator.hasNext()) {
                str = (String)listIterator.next();
            }
            else {
                break;
            }
            int beginIndex = str.length();
            while (true) {
                String substring = str.substring(0, beginIndex);
                if (treeMap.containsKey(substring)) {
                    String s3 = substring.intern();
                    assert !(!str.startsWith(s3));
                    assert s3.length() == beginIndex;
                    String substring2 = str.substring(beginIndex);
                    boolean n = false;
                    boolean n2 = false;
                    int nextIndex = listIterator2.nextIndex();
                    String[] array;
                Label_1128:
                    for (String s4 : array = (String[])treeMap.get(s3)) {
                        if (s4.length() != 0) {
                            if (s4.startsWith("#")) {
                                break;
                            }
                            int beginIndex2 = 0;
                            int n3 = s4.charAt(beginIndex2++);
                            int n4;
                            switch (n3) {
                                case 43: {
                                    n4 = ((substring2.length() != 0) ? 1 : 0);
                                    n3 = s4.charAt(beginIndex2++);
                                    break;
                                }
                                case 42: {
                                    n4 = 1;
                                    n3 = s4.charAt(beginIndex2++);
                                    break;
                                }
                                default: {
                                    n4 = ((substring2.length() == 0) ? 1 : 0);
                                    break;
                                }
                            }
                            if (n4 != 0) {
                                String s5 = s4.substring(beginIndex2);
                                switch (n3) {
                                    case 46: {
                                        string = ((s5.length() != 0) ? s5.intern() : s3);
                                        break Label_1211;
                                    }
                                    case 63: {
                                        string = ((s5.length() != 0) ? s5.intern() : str);
                                        n2 = true;
                                        break Label_1128;
                                    }
                                    case 64: {
                                        s3 = s5.intern();
                                        break;
                                    }
                                    case 62: {
                                        listIterator2.add(s5 + substring2);
                                        substring2 = "";
                                        break;
                                    }
                                    case 33: {
                                        s3 = ((s5.length() != 0) ? s5.intern() : s3);
                                        map.remove(s3);
                                        map.put(s3, null);
                                        n = true;
                                        break;
                                    }
                                    case 36: {
                                        if (s5.length() != 0) {
                                        }
                                        else {
                                            String s6 = (String)map.get(s3);
                                            if (s6 == null || s6.length() == 0) {
                                                s5 = "1";
                                            }
                                            else {
                                                s5 = "" + (1 + Integer.parseInt(s6));
                                            }
                                        }
                                        map.put(s3, s5);
                                        n = true;
                                        break;
                                    }
                                    case 38:
                                    case 61: {
                                        int n5 = n3 == '&';
                                        String string2;
                                        if (listIterator2.hasPrevious()) {
                                            string2 = (String)listIterator2.previous();
                                            listIterator2.remove();
                                        }
                                        else if (listIterator.hasNext()) {
                                            string2 = (String)listIterator.next();
                                        }
                                        else {
                                            string = str + " ?";
                                            n2 = true;
                                            break Label_1128;
                                        }
                                        if (!(n5 == 0)) {
                                            String str2 = (String)map.get(s3);
                                            if (str2 != null) {
                                                if (s5.length() != 0) {}
                                                string2 = str2 + s5 + string2;
                                            }
                                        }
                                        map.put(s3, string2);
                                        n = true;
                                        break;
                                    }
                                    default: {
                                        throw new RuntimeException(MessageFormat.format(Driver.RESOURCE.getString("BAD_SPEC"), new Object[] { s3, s4 }));
                                    }
                                }
                            }
                        }
                    }
                    if (n && n2 == 0) {
                        continue Label_1211;
                    }
                    while (listIterator2.nextIndex() > nextIndex) {
                        listIterator2.previous();
                        listIterator2.remove();
                    }
                    if (!(n2 == 0)) {
                        throw new IllegalArgumentException(string);
                    }
                    if (beginIndex == 0) {
                        break;
                    }
                    --beginIndex;
                }
                else {
                    if (beginIndex == 0) {
                        break;
                    }
                    SortedMap<Object, Object> headMap = treeMap.headMap(substring);
                    beginIndex = Math.min(headMap.isEmpty() ? 0 : ((String)headMap.lastKey()).length(), beginIndex - 1);
                    str.substring(0, beginIndex);
                }
            }
            listIterator2.add(str);
            break;
        }
        list.subList(0, listIterator.nextIndex()).clear();
        while (listIterator2.hasPrevious()) {
            list.add(0, listIterator2.previous());
        }
        return string;
    }
    
    static {
        RESOURCE = ResourceBundle.getBundle("com.sun.java.util.jar.pack.DriverResource");
        PACK200_PROPERTY_TO_OPTION = new String[] { "pack.segment.limit", "--segment-limit=", "pack.keep.file.order", "--no-keep-file-order", "pack.effort", "--effort=", "pack.deflate.hint", "--deflate-hint=", "pack.modification.time", "--modification-time=", "pack.pass.file.", "--pass-file=", "pack.unknown.attribute", "--unknown-attribute=", "pack.class.attribute.", "--class-attribute=", "pack.field.attribute.", "--field-attribute=", "pack.method.attribute.", "--method-attribute=", "pack.code.attribute.", "--code-attribute=", "com.sun.java.util.jar.pack.verbose", "--verbose", "com.sun.java.util.jar.pack.strip.debug", "--strip-debug" };
        UNPACK200_PROPERTY_TO_OPTION = new String[] { "unpack.deflate.hint", "--deflate-hint=", "com.sun.java.util.jar.pack.verbose", "--verbose", "com.sun.java.util.jar.pack.unpack.remove.packfile", "--remove-pack-file" };
    }
}
